#!/bin/bash


rm -rf csv
mkdir csv
cd csv
touch coin_list.json last_update.csv scroll_text.csv crypto_settings.json last_updates.json settings.csv
touch currency.json league_tables.json
mkdir sports
touch current_weather.json stocks_settings.json daily_weather.json live_games.json 
touch display_settings.json  message_settings.json  upcoming_games.json forex_settings.json multiple.csv
touch GIF_settings.json news_settings.json image_settings.json past_games.json

filenames="coin_list.json last_update.csv scroll_text.csv crypto_settings.json last_updates.json settings.csv league_tables.json current_weather.json stocks_settings.json daily_weather.json live_games.json display_settings.json  message_settings.json  upcoming_games.json forex_settings.json multiple.csv GIF_settings.json news_settings.json image_settings.json past_games.json"


echo [\"Standard\", [\"Crypto\", \"Forex\"]] >> display_settings.json

echo hello world!,255,255,0 >> scroll_text.csv 
echo {\"feature\": \"Stocks\", \"speed\": \"medium\", \"animation\": \"down\", \"percent\": false, \"point\": false, \"logos\": true, \"chart\": false, \"title\": true, \"symbols\": {\"NEO,USD\": {\"current\": 40.64, \"24hr_change\": -4.545324570981437}, \"BTC,USD\": {\"current\": 56740, \"24hr_change\": -5.016422821619689}, \"ETH,BTC\": {\"current\": 0.07348605, \"24hr_change\": -4.828763639147195}, \"ADA,GBP\": {\"current\": 1.33, \"24hr_change\": -4.802144813755147}}} >> crypto_settings.json 
echo -e "speed,brightness\nf,3" >> settings.csv

echo '{"feature": "Sports (Team Stats)", "speed": "medium", "animation": "down", "title": true, "leagues": {}}' >> league_tables.json
echo {\"feature\": \"Current Weather\", \"speed\": \"medium\", \"animation\": \"down\", \"temp\": \"celsius\", \"wind_speed\": \"miles/sec\", \"colour\": \"white\", \"city_colour\": \"yellow\", \"title\": true, \"locations\": {}, \"current_weather\": true} >> current_weather.json 
echo {\"feature\": \"Stocks\", \"speed\": \"medium\", \"animation\": \"down\", \"percent\": true, \"point\": true, \"logos\": false, \"chart\": false, \"title\": true, \"symbols\": {\"MSFT\": {\"current\": 342.875, \"opening\": 344.57}, \"GOOG\": {\"current\": 2956.35, \"opening\": 3006.525}}} >> stocks_settings.json 
echo {\"feature\": \"Current Weather\", \"speed\": \"medium\", \"animation\": \"down\", \"temp\": \"celsius\", \"wind_speed\": \"miles/sec\", \"colour\": \"white\", \"city_colour\": \"yellow\", \"title\": true, \"locations\": {}, \"current_weather\": true} >> daily_weather.json 
echo '{"feature": "Sports (Live Games)", "speed": "medium", "animation": "down", "title": true, "leagues": {}}' >> live_games.json
echo '{"feature": "Custom Messages", "speed": "Medium", "animation": "down", "title": true, "messages": [{"name": "1", "text": "123", "text_colour": "White", "size": "Medium", "background_colour": "Black"}, {"name": "13", "text": "123", "text_colour": "Red", "size": "Medium", "background_colour": "Purple"}]}' >> message_settings.json 
echo '{"feature": "Sports (Upcoming Games)", "speed": "medium", "animation": "down", "title": true, "leagues": {"NFL": [{"date": "2021-11-22", "time": "01:20:00", "round": "11", "home_team": "Los Angeles Chargers", "home_score": "41", "away_team": "Pittsburgh Steelers", "away_score": "37"}, {"date": "2021-11-23", "time": "01:15:00", "round": "11", "home_team": "Tampa Bay Buccaneers", "home_score": "0", "away_team": "New York Giants", "away_score": "0"}, {"date": "2021-11-25", "time": "17:30:00", "round": "12", "home_team": "Detroit Lions", "home_score": null, "away_team": "Chicago Bears", "away_score": null}, {"date": "2021-11-25", "time": "21:30:00", "round": "12", "home_team": "Dallas Cowboys", "home_score": null, "away_team": "Las Vegas Raiders", "away_score": null}, {"date": "2021-11-26", "time": "01:20:00", "round": "12", "home_team": "New Orleans Saints", "home_score": null, "away_team": "Buffalo Bills", "away_score": null}, {"date": "2021-11-28", "time": "18:00:00", "round": "12", "home_team": "Cincinnati Bengals", "home_score": null, "away_team": "Pittsburgh Steelers", "away_score": null}, {"date": "2021-11-28", "time": "18:00:00", "round": "12", "home_team": "Houston Texans", "home_score": null, "away_team": "New York Jets", "away_score": null}, {"date": "2021-11-28", "time": "18:00:00", "round": "12", "home_team": "Indianapolis Colts", "home_score": null, "away_team": "Tampa Bay Buccaneers", "away_score": null}, {"date": "2021-11-28", "time": "18:00:00", "round": "12", "home_team": "Jacksonville Jaguars", "home_score": null, "away_team": "Atlanta Falcons", "away_score": null}, {"date": "2021-11-28", "time": "18:00:00", "round": "12", "home_team": "Miami Dolphins", "home_score": null, "away_team": "Carolina Panthers", "away_score": null}, {"date": "2021-11-28", "time": "18:00:00", "round": "12", "home_team": "New England Patriots", "home_score": null, "away_team": "Tennessee Titans", "away_score": null}, {"date": "2021-11-28", "time": "18:00:00", "round": "12", "home_team": "New York Giants", "home_score": null, "away_team": "Philadelphia Eagles", "away_score": null}, {"date": "2021-11-28", "time": "21:05:00", "round": "12", "home_team": "Denver Broncos", "home_score": null, "away_team": "Los Angeles Chargers", "away_score": null}, {"date": "2021-11-28", "time": "21:25:00", "round": "12", "home_team": "Green Bay Packers", "home_score": null, "away_team": "Los Angeles Rams", "away_score": null}, {"date": "2021-11-28", "time": "21:25:00", "round": "12", "home_team": "San Francisco 49ers", "home_score": null, "away_team": "Minnesota Vikings", "away_score": null}], "NBA": [{"date": "2021-11-22", "time": "01:20:00", "round": "11", "home_team": "Los Angeles Chargers", "home_score": "41", "away_team": "Pittsburgh Steelers", "away_score": "37"}, {"date": "2021-11-23", "time": "01:15:00", "round": "11", "home_team": "Tampa Bay Buccaneers", "home_score": "0", "away_team": "New York Giants", "away_score": "0"}, {"date": "2021-11-25", "time": "17:30:00", "round": "12", "home_team": "Detroit Lions", "home_score": null, "away_team": "Chicago Bears", "away_score": null}, {"date": "2021-11-25", "time": "21:30:00", "round": "12", "home_team": "Dallas Cowboys", "home_score": null, "away_team": "Las Vegas Raiders", "away_score": null}, {"date": "2021-11-26", "time": "01:20:00", "round": "12", "home_team": "New Orleans Saints", "home_score": null, "away_team": "Buffalo Bills", "away_score": null}, {"date": "2021-11-28", "time": "18:00:00", "round": "12", "home_team": "Cincinnati Bengals", "home_score": null, "away_team": "Pittsburgh Steelers", "away_score": null}, {"date": "2021-11-28", "time": "18:00:00", "round": "12", "home_team": "Houston Texans", "home_score": null, "away_team": "New York Jets", "away_score": null}, {"date": "2021-11-28", "time": "18:00:00", "round": "12", "home_team": "Indianapolis Colts", "home_score": null, "away_team": "Tampa Bay Buccaneers", "away_score": null}, {"date": "2021-11-28", "time": "18:00:00", "round": "12", "home_team": "Jacksonville Jaguars", "home_score": null, "away_team": "Atlanta Falcons", "away_score": null}, {"date": "2021-11-28", "time": "18:00:00", "round": "12", "home_team": "Miami Dolphins", "home_score": null, "away_team": "Carolina Panthers", "away_score": null}, {"date": "2021-11-28", "time": "18:00:00", "round": "12", "home_team": "New England Patriots", "home_score": null, "away_team": "Tennessee Titans", "away_score": null}, {"date": "2021-11-28", "time": "18:00:00", "round": "12", "home_team": "New York Giants", "home_score": null, "away_team": "Philadelphia Eagles", "away_score": null}, {"date": "2021-11-28", "time": "21:05:00", "round": "12", "home_team": "Denver Broncos", "home_score": null, "away_team": "Los Angeles Chargers", "away_score": null}, {"date": "2021-11-28", "time": "21:25:00", "round": "12", "home_team": "Green Bay Packers", "home_score": null, "away_team": "Los Angeles Rams", "away_score": null}, {"date": "2021-11-28", "time": "21:25:00", "round": "12", "home_team": "San Francisco 49ers", "home_score": null, "away_team": "Minnesota Vikings", "away_score": null}]}}' >> upcoming_games.json
echo '{"feature": "Stocks", "speed": "medium", "animation": "down", "percent": false, "point": false, "logos": false, "chart": false, "title": true, "symbols": {"NZD,GBP": {"current": 1.9181, "24hr_change": 0.0046999999999999265}, "CAD,USD": {"current": 1.2647, "24hr_change": 0.0046999999999999265}}}' >> forex_settings.json
echo '{"speed": "medium", "animation": "down", "title": true, "pause": "2", "images": []}'>> GIF_settings.json
echo '{"feature": "News", "speed": "medium", "animation": "down", "country": "USA", "category": "general", "title": true, "use_sources": true, "sources": [], "headlines": []}' >> news_settings.json
echo '{"speed": "slow", "animation": "down", "title": true, "pause": "/", "images": []}' >> image_settings.json
echo '{"feature": "Sports (Past Games)", "speed": "medium", "animation": "down", "title": true, "leagues": {}}' >> past_games.json

cd sports
mkdir NBA
mkdir NFL
mkdir NHL
mkdir 'Premier League'

cd NBA
touch future_games.json live_games.json past_games.json team_info.csv team_stats.json
echo [] >> future_games.json
echo [] >> live_games.json
echo [] >> past_games.json
echo [] >> team_info.csv
echo [] >> team_stats.json

cd ..
cd NFL
touch future_games.json live_games.json past_games.json team_info.csv team_stats.json
echo [] >> future_games.json
echo [] >> live_games.json
echo [] >> past_games.json
echo [] >> team_info.csv
echo [] >> team_stats.json

cd ..
cd NHL
touch future_games.json live_games.json past_games.json team_info.csv team_stats.json
echo [] >> future_games.json
echo [] >> live_games.json
echo [] >> past_games.json
echo [] >> team_info.csv
echo [] >> team_stats.json

cd ..
cd 'Premier League'
touch future_games.json live_games.json past_games.json team_info.csv team_stats.json
echo [] >> future_games.json
echo [] >> live_games.json
echo [] >> past_games.json
echo [] >> team_info.csv
echo [] >> team_stats.json

cd ../../..
sudo chmod -R ugo+rwx csv

rm -rf display_images
mkdir display_images
cd display_images
touch 'Crypto Prof.ppm'
touch 'Crypto.ppm'
touch 'Current Weather Prof.ppm'
touch 'Current Weather.ppm'
touch 'Custom GIFs.gif'
touch 'Custom Images.ppm'
touch 'Custom Messages.ppm'
touch 'Daily Forecast.ppm'
touch 'Forex Prof.ppm'
touch 'Forex.ppm'
touch 'News Prof.ppm'
touch 'News.ppm'
touch 'Sports (Live Games).ppm'
touch 'Sports (Past Games).ppm'
touch 'Sports (Team Stats).ppm'
touch 'Sports (Upcoming Games).ppm'
touch 'Stocks Prof.ppm'
touch 'Stocks.ppm'
touch 'daily_weather.ppm'
touch 'display_gif.gif'
touch 'display_gif.ppm'
touch 'display_image.ppm'


cd ..
sudo chmod -R ugo+rwx display_images

